local L = AceLibrary("AceLocale-2.2"):new("DrDamage")

DrDamage.PlayerAura = {}
DrDamage.TargetAura = {}
DrDamage.Consumables = {}
DrDamage.Calculation = {}

local function DrD_LoadAuras()
	local playerClass = select(2,UnitClass("player"))
	local playerHealer = (playerClass == "PRIEST") or (playerClass == "SHAMAN") or (playerClass == "PALADIN") or (playerClass == "DRUID")
	local playerCaster = (playerClass == "MAGE") or (playerClass == "PRIEST") or (playerClass == "WARLOCK")
	local playerMelee = (playerClass == "ROGUE") or (playerClass == "WARRIOR") or (playerClass == "HUNTER")
	local playerHybrid = (playerClass == "DEATHKNIGHT") or (playerClass == "DRUID") or (playerClass == "PALADIN") or (playerClass == "SHAMAN")	
	local Aura = DrDamage.PlayerAura
	local GetSpellInfo = GetSpellInfo
	local arcane, fire, frost, nature, shadow, holy
	
	if playerCaster or playerHybrid then
		arcane = (playerClass == "DRUID") or (playerClass == "MAGE")
		fire = (playerClass == "SHAMAN") or (playerClass == "WARLOCK") or (playerClass == "MAGE")
		frost = (playerClass == "DEATHKNIGHT") or (playerClass == "SHAMAN") or (playerClass == "MAGE")
		nature = (playerClass == "SHAMAN") or (playerClass == "DRUID")
		shadow = (playerClass == "DEATHKNIGHT") or (playerClass == "PRIEST") or (playerClass == "WARLOCK")
		holy = (playerClass == "PRIEST") or (playerClass == "PALADIN")
	end
	
	--Bloodlust
	Aura[GetSpellInfo(2825)] = { School = "All", Mods = { ["castTime"] = function(v) return v/1.3 end } }
	--Heroism
	Aura[GetSpellInfo(32182)] = Aura[GetSpellInfo(2825)]
	--Heroic Presence
	Aura[GetSpellInfo(28878)] = { Value = 1, ModType = "hitPerc", }
	
	if playerCaster or playerHybrid then
		--Totem of Wrath
		Aura[GetSpellInfo(30706)] = { Caster = true, School = "All", Mods = { ["spellDmg"] = 280 } }
		--Wrath of Air
		Aura[GetSpellInfo(3738)] = { Caster = true, School = "All", Mods = { ["castTime"] = function(v) return v/1.05 end } }
		--Vibrant Blood
		Aura[GetSpellInfo(35329)] = { Caster = true, Value = 0.1 }
		--Bloodgem Infusion
		Aura[GetSpellInfo(34379)] = { Caster = true, School = "All", Value = 0.05, }
		--Power Infusion
		Aura[GetSpellInfo(10060)] = { Caster = true, School = "All", Mods = { ["castTime"] = function(v) return v/1.2 end } }
		--Moonkin Aura
		Aura[GetSpellInfo(24907)] = { Caster = true, School = "All", Mods = { ["critPerc"] = 5 } }
		--Elemental Oath
		Aura[GetSpellInfo(53414)] = { Caster = true, School = "All", Mods = { ["critPerc"] = 5 } }
	end
		
	if playerHealer then
		--A'dal's Song of Battle
		Aura[GetSpellInfo(39953)] = { School = "Healing", Value = 0.05 }
		--Vile Slime
		Aura[GetSpellInfo(40099)] = { School = "Healing", Value = -0.5 }
		--Debilitating Spray
		Aura[GetSpellInfo(40079)] = { School = "Healing", Value = -0.5 }
		--Vile Sludge
		Aura[GetSpellInfo(38246)] = { School = "Healing", Value = -0.5 }	
		--Nether Portal - Serenity
		Aura[GetSpellInfo(30422)] = { School = "Healing", Value = 0.05, Apps = 99 }
	end
	
	--Target debuffs
	Aura = DrDamage.TargetAura

	--Icebound Fortitude (How to implement this reduction properly?)
	Aura[GetSpellInfo(48792)] = { Value = -0.2 }
	--Bone Shield
	Aura[GetSpellInfo(49222)] = { Value = -0.2 }
	--Totem of Wrath
	Aura[GetSpellInfo(57722)] = { Value = 3, ModType = "critPerc" }
	--Heart of the Crusader
	Aura[GetSpellInfo(20335)] = { Value = 1, Ranks = 3, ModType = "critPerc" }
	--Master Poisoner
	Aura[GetSpellInfo(58410)] = { Value = 1, Ranks = 3, ModType = "critPerc" }
	--Focused Will
	Aura[GetSpellInfo(45234)] = { ModType = "Special" }
	local UnitExists = UnitExists
	local UnitIsFriend = UnitIsFriend
	DrDamage.Calculation[GetSpellInfo(45234)] = function( calculation, _, _, _, apps, _, rank )
		rank = rank and tonumber(string_match(rank,"%d+")) or 3
		apps = apps or 3
		if calculation.healingSpell then
			if not UnitExists("target") or UnitIsFriend("target","player") then
				calculation.dmgM = calculation.dmgM * (1 + (rank * 0.01 + 0.02) * apps)
			end
		elseif UnitExists("target") and not UnitIsFriend("target","player") then
			calculation.dmgM = calculation.dmgM * (1 - (rank * 0.01 + 0.01) * apps)
		end	
	end	
	
	
	if playerCaster or playerHybrid then
		--SCHOOL SPECIFIC
		--Shadow/Arcane/Fire/Frost/Nature Vulnerability
		if shadow or arcane or fire or frost or nature then 
			--Curse of the Elements
			Aura[GetSpellInfo(1490)] = { School = { "Shadow", "Arcane", "Fire", "Frost", "Nature", "Frostfire" }, Ranks = 5, Value = { 0.06, 0.08, 0.1, 0.1, 0.13 }, ActiveAura = "Soul Siphon", }
			--Earth and Moon 
			Aura[GetSpellInfo(60431)] = { School = { "Shadow", "Arcane", "Fire", "Frost", "Nature", "Frostfire" }, Ranks = 3, Value = { 0.04, 0.09, 0.13 }, }
		end
		
		--General	
		--Improved Shadow Bolt
		Aura[GetSpellInfo(17800)] = { Value = 1, Ranks = 5, ModType = "critPerc", Caster = true }
		--Misery
		Aura[GetSpellInfo(33196)] = { Value = 1, Ranks = 3, ModType = "hitPerc", Caster = true }		
		--Improved Scorch
		Aura[GetSpellInfo(22959)] = { Apps = 5, Value = 1, ModType = "critPerc", Caster = true }
		--Winter's Chill
		Aura[GetSpellInfo(12579)] = { Apps = 5, Value = 1, ModType = "critPerc", Caster = true }
		--Anti-Magic Shell
		Aura[GetSpellInfo(48707)] = { Value = -0.75, Caster = true }
		--Ebon Plague -- No easy way to tell what talent rank the Death Knight has without scanning the tooltip; for now assuming max rank.
		Aura[GetSpellInfo(51735)] = { Value = 0.13, Caster = true }
		
		--Weapon Debuffs
		--Spell Vulnerability (from Nightfall)
		Aura[GetSpellInfo(23605)] = { Value = 0.15, Caster = true }
		--Magic Disruption (Kael'thas fight Infinity Blade buff)
		Aura[GetSpellInfo(36478)] = { Value = 0.05, Apps = 5, Caster = true }
	end
	if playerHealer then
		--Amplify Magic
		Aura[GetSpellInfo(1008)] = { School = "Healing", ModType = "spellDmg", Ranks = 7, Value = { 16, 32, 53, 80, 96, 128, 255 }, }
		--Quick Recovery
		Aura[GetSpellInfo(31245)] = { School = "Healing", Ranks = 2, Value = 0.1 }
		--Demon Armor
		Aura[GetSpellInfo(27260)] = { School = "Healing", Value = 0.2, }
		--Curse of the Bleeding Hollow
		Aura[GetSpellInfo(34073)] = { School = "Healing", Value = -0.15 }
		--Wound Poison
		Aura[GetSpellInfo(43461)] = { School = "Healing", Apps = 5, Value = -0.1, }
		--Mortal Strike
		Aura[GetSpellInfo(12294)] = { School = "Healing", Value = -0.5, }
		--Veil of Shadow
		Aura[GetSpellInfo(17820)] = { School = "Healing", Value = -0.75, }
		--Nether Portal - Dominance
		Aura[GetSpellInfo(30423)] = { School = "Healing", Value = -0.01, Apps = 10 }
		--Divine Hymn
		Aura[GetSpellInfo(64844)] =  { School = "Healing", Value = 0.1 }
		--Guardian Spirit
		Aura[GetSpellInfo(47788)] =  { School = "Healing", Value = 0.4 }
		--Tree of Life
		Aura[GetSpellInfo(34123)] =  { School = "Healing", ModType = "Special" }
		local passive = select(2,GetSpellInfo(5420))
		DrDamage.Calculation[GetSpellInfo(34123)] = function( calculation, _, _, _, _, _, rank )
			if rank == passive then
				calculation.dmgM = calculation.dmgM * 1.06
			end
		end		
	end
	if playerMelee or playerHybrid then
		--Shadowform
		Aura[GetSpellInfo(15473)] = { School = { "Ranged", "Physical" }, Value = -0.15 }
		--Holyform
		Aura[GetSpellInfo(46565)] = { School = { "Ranged", "Physical" }, Value = -0.2 }
		--Armor Disruption
		Aura[GetSpellInfo(36482)] = { School = {"Ranged", "Physical" }, Value = 0.05, Apps = 5 }
		--Hemorrhage
		Aura[GetSpellInfo(16511)] = { School = { "Ranged", "Physical" }, Value = { 13, 21, 29, 42, 75 }, Ranks = 5, ModType = "dmgBonus" }
		-- Bleed bonuses for Trauma, Mangle (Bear) and Mangle (Cat)
		Aura[GetSpellInfo(46856)] = { School = "Physical", Value = { 0.15, 0.3 }, Ranks = 2, ModType = "bleedBonus" }
		Aura[GetSpellInfo(33878)] = { School = "Physical", Value = 0.3, ModType = "bleedBonus" }
		Aura[GetSpellInfo(33876)] = { School = "Physical", Value = 0.3, ModType = "bleedBonus" }
		--Lichborne
		Aura[GetSpellInfo(49039)] = { School = "Physical", Value = -25, ModType = "hitPerc" }
	end
	
	local Consumables = DrDamage.Consumables
	if arcane or holy or nature then
		Consumables[GetItemInfo(22861) or "Flask of Blinding Light"] = { School = { "Arcane", "Holy", "Nature" }, Mods = { ["spellDmg"] = 80 }, Alt = GetSpellInfo(46839) }
	end
	if shadow or fire or frost then
		Consumables[GetItemInfo(22866) or "Flask of Pure Death"] = { School = { "Shadow", "Fire", "Frost", "Frostfire" }, Mods = { ["spellDmg"] = 80 }, Alt = GetSpellInfo(46837) }
	end
	if shadow then
		Consumables[GetItemInfo(22835) or "Elixir of Major Shadow Power"] = { School = "Shadow", Mods = { ["spellDmg"] = 55 }, Alt = GetSpellInfo(28503) }
	end
	if fire then
		Consumables[GetItemInfo(22833) or "Elixir of Major Firepower"] = { School = { "Fire", "Frostfire" }, Mods = { ["spellDmg"] = 55 }, Alt = GetSpellInfo(28501) }
	end
	if frost then
		Consumables[GetItemInfo(22827) or "Elixir of Major Frost Power"] = { School = { "Frost", "Frostfire"}, Mods = { ["spellDmg"] = 55 }, Alt = GetSpellInfo(28493) }
	end
	if playerHealer then
		Consumables[GetItemInfo(22825) or "Elixir of Healing Power"] = { School = "Healing", Mods = { ["spellDmg"] = 50 }, Alt = GetSpellInfo(28491) }
		Consumables[GetItemInfo(20748) or "Brilliant Mana Oil"] = { School = "Healing", Mods = { ["manaRegen"] = 2.4, ["spellDmg"] = 25 }, Oil = true }
		Consumables[GetItemInfo(22521) or "Superior Mana Oil"] = { School = "All", Mods = { ["manaRegen"] = 2.8 }, Oil = true }
		
		Consumables[L["+44 Healing Food"]] = { School = "Healing", Mods = { ["spellDmg"] = 44 }, Alt = GetSpellInfo(33263) }
	end
	if playerCaster or playerHybrid or playerHealer then
		--Adept's Elixir
		Consumables[GetSpellInfo(33721)] = { School = "All", Mods = { ["spellDmg"] = 24, ["critPerc"] = 1.08696 } }
		Consumables[GetItemInfo(13512) or "Flask of Supreme Power"] = { Mods = { ["spellDmg"] = 70 }, Alt = GetSpellInfo(32900) }
		Consumables[GetItemInfo(22522) or "Superior Wizard Oil"] = { School = "All", Mods = { ["spellDmg"] = 42 }, Oil = true }
		Consumables[GetItemInfo(20749) or "Brilliant Wizard Oil"] = { School = "All", Mods = { ["spellDmg"] = 36, ["critPerc"] = 0.634 }, Oil = true }
		Consumables[GetItemInfo(22853) or "Flask of Mighty Restoration"] = { School = "All", Mods = { ["manaRegen"] = 5 }, Alt = GetSpellInfo(41610) }
		Consumables[GetItemInfo(22840) or "Elixir of Major Mageblood"] = { School = "All", Mods = { ["manaRegen"] = 3.2 }, Alt = GetSpellInfo(28509) }
		
		Consumables[L["+23 Damage Food"]] = { Mods = { ["spellDmg"] = 23, }, Alt = GetSpellInfo(33263) }
		Consumables[L["+20 Spell Critical Strike Food"]] = { School = "All", Mods = { ["critPerc"] = 0.9058 }, Alt = GetSpellInfo(33263) }
	end
	if playerMelee or playerHybrid then
		Consumables[GetItemInfo(22854) or "Flask of Relentless Assault"] = { School = { "Ranged", "Physical" }, Mods = { ["AP"] = 120 }, Alt = GetSpellInfo(41608) }
		--Elixir of Demonslaying
		Consumables[GetSpellInfo(11406)] = { School = { "Physical", "Ranged" }, Mods = { ["AP"] = 265 }, }
		
		Consumables[L["+40 AP Food"]] = { School = { "Ranged", "Physical" }, Mods = { ["AP"] = 40 }, Alt = GetSpellInfo(33263) }
		Consumables[L["+20 Hit Rating Food"]] = { School = { "Ranged", "Physical" }, Mods = { ["hitPerc"] = 1.269 }, Alt = GetSpellInfo(33263) }
	end
end

DrD_LoadAuras()
DrD_LoadAuras = nil